import * as ts from 'typescript';
import { MetaModel, EnumerationType } from './metaModel';
export declare type TypeInfoKind = 'base' | 'reference' | 'array' | 'map' | 'intersection' | 'union' | 'tuple' | 'literal' | 'stringLiteral' | 'integerLiteral' | 'booleanLiteral';
export default class Visitor {
    #private;
    private readonly program;
    private readonly typeChecker;
    private readonly symbols;
    private readonly requests;
    private readonly notifications;
    private readonly structures;
    private readonly enumerations;
    private readonly typeAliases;
    private readonly symbolQueue;
    private readonly processedStructures;
    constructor(program: ts.Program);
    protected get currentSourceFile(): ts.SourceFile;
    visitProgram(): Promise<void>;
    endVisitProgram(): Promise<void>;
    getMetaModel(): MetaModel;
    protected visit(node: ts.Node): void;
    private doVisit;
    private visitGeneric;
    private endVisitGeneric;
    private visitSourceFile;
    private endVisitSourceFile;
    private visitModuleDeclaration;
    private visitRequest;
    private visitNotification;
    private visitTypeReference;
    private queueTypeInfo;
    private queueSymbol;
    private endVisitModuleDeclaration;
    private getSourceFilesToIndex;
    private getMethodName;
    private getRegistrationMethodName;
    private getMessageDirection;
    private getRequestTypes;
    private getNotificationTypes;
    private getTypeInfo;
    private getBaseTypeInfo;
    private static readonly Mixins;
    private static readonly PropertyFilters;
    private static readonly PropertyRenames;
    private processSymbol;
    private fillProperties;
    private splitIntersectionType;
    private getFirstDeclaration;
    private getDeclaration;
    private getEnumValues;
    private getEnumValue;
    getEnumBaseType(values: string[] | number[]): EnumerationType | undefined;
    private removeQuotes;
    private fillDocProperties;
    private getDocumentation;
    private getTags;
}
